# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xaddomain`](#dsc_xaddomain): The DSC xADDomain resource type. Automatically generated from version 2.10.0.0
* [`dsc_xaddomaincontroller`](#dsc_xaddomaincontroller): The DSC xADDomainController resource type. Automatically generated from version 2.10.0.0
* [`dsc_xaddomaindefaultpasswordpolicy`](#dsc_xaddomaindefaultpasswordpolicy): The DSC xADDomainDefaultPasswordPolicy resource type. Automatically generated from version 2.10.0.0
* [`dsc_xaddomaintrust`](#dsc_xaddomaintrust): The DSC xADDomainTrust resource type. Automatically generated from version 2.10.0.0
* [`dsc_xadgroup`](#dsc_xadgroup): The DSC xADGroup resource type. Automatically generated from version 2.10.0.0
* [`dsc_xadorganizationalunit`](#dsc_xadorganizationalunit): The DSC xADOrganizationalUnit resource type. Automatically generated from version 2.10.0.0
* [`dsc_xadrecyclebin`](#dsc_xadrecyclebin): The DSC xADRecycleBin resource type. Automatically generated from version 2.10.0.0
* [`dsc_xaduser`](#dsc_xaduser): The DSC xADUser resource type. Automatically generated from version 2.10.0.0
* [`dsc_xwaitforaddomain`](#dsc_xwaitforaddomain): The DSC xWaitForADDomain resource type. Automatically generated from version 2.10.0.0

## Resource types

### `dsc_xaddomain`

The DSC xADDomain resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xaddomain` type.

##### `dsc_databasepath`

Data type: `Optional[String]`

Path to a directory that contains the domain database

##### `dsc_domainnetbiosname`

Data type: `Optional[String]`

NetBIOS name for the new domain

##### `dsc_logpath`

Data type: `Optional[String]`

Path to a directory for the log file that will be written

##### `dsc_parentdomainname`

Data type: `Optional[String]`

Fully qualified name of the parent domain

##### `dsc_sysvolpath`

Data type: `Optional[String]`

Path to a directory where the Sysvol file will be written

#### Parameters

The following parameters are available in the `dsc_xaddomain` type.

##### `dsc_dnsdelegationcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential used for creating DNS delegation

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to query for domain existence

##### `dsc_domainname`

namevar

Data type: `String`

Name of the domain to which the user will be added

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_safemodeadministratorpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Password for the administrator account when the computer is started in Safe Mode

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaddomaincontroller`

The DSC xADDomainController resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xaddomaincontroller` type.

##### `dsc_databasepath`

Data type: `Optional[String]`

 

##### `dsc_logpath`

Data type: `Optional[String]`

 

##### `dsc_sysvolpath`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xaddomaincontroller` type.

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_domainname`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_safemodeadministratorpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaddomaindefaultpasswordpolicy`

The DSC xADDomainDefaultPasswordPolicy resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xaddomaindefaultpasswordpolicy` type.

##### `dsc_complexityenabled`

Data type: `Optional[Boolean]`

Whether password complexity is enabled for the default password policy

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Active Directory domain controller to enact the change upon

##### `dsc_lockoutduration`

Data type: `Optional[Integer[0, 4294967295]]`

Length of time that an account is locked after the number of failed login attempts (minutes)

##### `dsc_lockoutobservationwindow`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum time between two unsuccessful login attempts before the counter is reset to 0 (minutes)

##### `dsc_lockoutthreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Number of unsuccessful login attempts that are permitted before an account is locked out

##### `dsc_maxpasswordage`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum length of time that you can have the same password (minutes)

##### `dsc_minpasswordage`

Data type: `Optional[Integer[0, 4294967295]]`

Minimum length of time that you can have the same password (minutes)

##### `dsc_minpasswordlength`

Data type: `Optional[Integer[0, 4294967295]]`

Minimum number of characters that a password must contain

##### `dsc_passwordhistorycount`

Data type: `Optional[Integer[0, 4294967295]]`

Number of previous passwords to remember

##### `dsc_reversibleencryptionenabled`

Data type: `Optional[Boolean]`

Whether the directory must store passwords using reversible encryption

#### Parameters

The following parameters are available in the `dsc_xaddomaindefaultpasswordpolicy` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to access the domain

##### `dsc_domainname`

namevar

Data type: `String`

Name of the domain to which the password policy will be applied

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaddomaintrust`

The DSC xADDomainTrust resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xaddomaintrust` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this resource be present or absent

##### `dsc_trustdirection`

Data type: `Enum['Bidirectional', 'Inbound', 'Outbound']`

Direction of trust

##### `dsc_trusttype`

Data type: `Enum['External', 'Forest']`

Type of trust

#### Parameters

The following parameters are available in the `dsc_xaddomaintrust` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_sourcedomainname`

namevar

Data type: `String`

Name of the AD domain that is requesting the trust

##### `dsc_targetdomainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials to authenticate to the target domain

##### `dsc_targetdomainname`

namevar

Data type: `String`

Name of the AD domain that is being trusted

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xadgroup`

The DSC xADGroup resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xadgroup` type.

##### `dsc_category`

Data type: `Optional[Enum['Security', 'Distribution']]`

Active Directory group category

##### `dsc_description`

Data type: `Optional[String]`

Description of the Active Directory group

##### `dsc_displayname`

Data type: `Optional[String]`

Display name of the Active Directory group

##### `dsc_domaincontroller`

Data type: `Optional[String]`

Active Directory domain controller to enact the change upon

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this resource be present or absent

##### `dsc_groupscope`

Data type: `Optional[Enum['DomainLocal', 'Global', 'Universal']]`

Active Directory group scope

##### `dsc_managedby`

Data type: `Optional[String]`

Active Directory managed by attribute specified as a DistinguishedName

##### `dsc_members`

Data type: `Optional[Array[String]]`

Active Directory group membership should match membership exactly

##### `dsc_membershipattribute`

Data type: `Optional[Enum['SamAccountName', 'DistinguishedName', 'ObjectGUID', 'SID']]`

Active Directory attribute used to perform membership operations

##### `dsc_memberstoexclude`

Data type: `Optional[Array[String]]`

Active Directory group should NOT include these members

##### `dsc_memberstoinclude`

Data type: `Optional[Array[String]]`

Active Directory group should include these members

##### `dsc_notes`

Data type: `Optional[String]`

Active Directory group notes field

##### `dsc_path`

Data type: `Optional[String]`

Location of the group within Active Directory expressed as a Distinguished Name

#### Parameters

The following parameters are available in the `dsc_xadgroup` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credentials used to enact the change upon

##### `dsc_groupname`

namevar

Data type: `String`

Name of the Active Directory group

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xadorganizationalunit`

The DSC xADOrganizationalUnit resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xadorganizationalunit` type.

##### `dsc_description`

Data type: `Optional[String]`

The description of the OU

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_protectedfromaccidentaldeletion`

Data type: `Optional[Boolean]`

Defaults to True

#### Parameters

The following parameters are available in the `dsc_xadorganizationalunit` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential to be used to perform the operation on Active Directory

##### `dsc_name`

namevar

Data type: `String`

The name of OU

##### `dsc_path`

namevar

Data type: `String`

Specifies the X500 path of the OU or container where the new object is created

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xadrecyclebin`

The DSC xADRecycleBin resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xadrecyclebin` type.

##### `dsc_forestmode`

Data type: `Optional[String]`

 

##### `dsc_recyclebinenabled`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xadrecyclebin` type.

##### `dsc_enterpriseadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_forestfqdn`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xaduser`

The DSC xADUser resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xaduser` type.

##### `dsc_cannotchangepassword`

Data type: `Optional[Boolean]`

 

##### `dsc_city`

Data type: `Optional[String]`

 

##### `dsc_commonname`

Data type: `Optional[String]`

 

##### `dsc_company`

Data type: `Optional[String]`

 

##### `dsc_country`

Data type: `Optional[String]`

 

##### `dsc_department`

Data type: `Optional[String]`

 

##### `dsc_description`

Data type: `Optional[String]`

 

##### `dsc_displayname`

Data type: `Optional[String]`

 

##### `dsc_distinguishedname`

Data type: `Optional[String]`

 

##### `dsc_division`

Data type: `Optional[String]`

 

##### `dsc_domaincontroller`

Data type: `Optional[String]`

 

##### `dsc_emailaddress`

Data type: `Optional[String]`

 

##### `dsc_employeeid`

Data type: `Optional[String]`

 

##### `dsc_employeenumber`

Data type: `Optional[String]`

 

##### `dsc_enabled`

Data type: `Optional[Boolean]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_fax`

Data type: `Optional[String]`

 

##### `dsc_givenname`

Data type: `Optional[String]`

 

##### `dsc_homedirectory`

Data type: `Optional[String]`

 

##### `dsc_homedrive`

Data type: `Optional[String]`

 

##### `dsc_homepage`

Data type: `Optional[String]`

 

##### `dsc_homephone`

Data type: `Optional[String]`

 

##### `dsc_initials`

Data type: `Optional[String]`

 

##### `dsc_ipphone`

Data type: `Optional[String]`

 

##### `dsc_jobtitle`

Data type: `Optional[String]`

 

##### `dsc_logonscript`

Data type: `Optional[String]`

 

##### `dsc_manager`

Data type: `Optional[String]`

 

##### `dsc_mobilephone`

Data type: `Optional[String]`

 

##### `dsc_notes`

Data type: `Optional[String]`

 

##### `dsc_office`

Data type: `Optional[String]`

 

##### `dsc_officephone`

Data type: `Optional[String]`

 

##### `dsc_pager`

Data type: `Optional[String]`

 

##### `dsc_passwordneverexpires`

Data type: `Optional[Boolean]`

 

##### `dsc_path`

Data type: `Optional[String]`

 

##### `dsc_pobox`

Data type: `Optional[String]`

 

##### `dsc_postalcode`

Data type: `Optional[String]`

 

##### `dsc_profilepath`

Data type: `Optional[String]`

 

##### `dsc_state`

Data type: `Optional[String]`

 

##### `dsc_streetaddress`

Data type: `Optional[String]`

 

##### `dsc_surname`

Data type: `Optional[String]`

 

##### `dsc_userprincipalname`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xaduser` type.

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_domainname`

namevar

Data type: `String`

 

##### `dsc_password`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_username`

namevar

Data type: `String`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xwaitforaddomain`

The DSC xWaitForADDomain resource type.
Automatically generated from version 2.10.0.0

#### Properties

The following properties are available in the `dsc_xwaitforaddomain` type.

##### `dsc_rebootretrycount`

Data type: `Optional[Integer[0, 4294967295]]`

 

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

 

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 18446744073709551615]]`

 

#### Parameters

The following parameters are available in the `dsc_xwaitforaddomain` type.

##### `dsc_domainname`

namevar

Data type: `String`

 

##### `dsc_domainusercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

